# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ros_monitoring_msgs/MetricData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ros_monitoring_msgs.msg
import genpy
import std_msgs.msg

class MetricData(genpy.Message):
  _md5sum = "f32b9a0e7a8e0cc5e657261689f3e49d"
  _type = "ros_monitoring_msgs/MetricData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header

# Constants for commonly used units
string UNIT_SEC=sec
string UNIT_MILLI_SEC=msec
string UNIT_MICRO_SEC=usec
string UNIT_PERCENTAGE=percent
string UNIT_COUNT=count
string UNIT_COUNT_PER_SEC=count_per_sec
string UNIT_BYTES=bytes
string UNIT_KILOBYTES=kilobytes
string UNIT_MEGABYTES=megabytes
string UNIT_GIGABYTES=gigabytes
string UNIT_TERABYTES=terabytes
string UNIT_BYTES_PER_SEC=bytes_per_sec
string UNIT_KILOBYTES_PER_SEC=kilobytes_per_sec
string UNIT_MEGABYTES_PER_SEC=megabytes_per_sec
string UNIT_GIGABYTES_PER_SEC=gigabytes_per_sec
string UNIT_TERABYTES_PER_SEC=terabytes_per_sec
string UNIT_NONE=none

# Constant for NA string
string NA_STRING=non_applicable_string_value

#####################################
# required fields

# The name for the metric
string metric_name

# The units applied to the value
string unit

# The value of the metric
float64 value

# The time since the epoch
time time_stamp

# optional Custom dimensions used to group/sort metrics
MetricDimension[] dimensions

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: ros_monitoring_msgs/MetricDimension
###################################
# Metric Dimensions provide an additional way to group, sort, and filter metrics.
#
# For example, you may have a large number of robots running in different factories. They are all publishing a metric
# that indicates how long it takes them to perform a specific task. If we're just looking at all the metrics coming from
# all the robots then we lose the ability to figure out things like if robots in one factory take longer to perform a
# task than in another factory. Dimensions allow us to solve this by include a dimension name "factory" with the factory
# name the robot is running in with each metric it publishes. Then we could look at the metrics for all robots or filter
# down to just robots in a specific factory.
#
# Additionally, if we wanted to A/B test software versions we could add another dimension named "software_version" that
# has a value set to the version of software the metric is produced from. Then we could group by the version of software
# as well as which factory the robot is in.
#
###################################

# The name of the Metric Dimension
string name

# The value for the dimension
string value
"""
  # Pseudo-constants
  UNIT_SEC = 'sec'
  UNIT_MILLI_SEC = 'msec'
  UNIT_MICRO_SEC = 'usec'
  UNIT_PERCENTAGE = 'percent'
  UNIT_COUNT = 'count'
  UNIT_COUNT_PER_SEC = 'count_per_sec'
  UNIT_BYTES = 'bytes'
  UNIT_KILOBYTES = 'kilobytes'
  UNIT_MEGABYTES = 'megabytes'
  UNIT_GIGABYTES = 'gigabytes'
  UNIT_TERABYTES = 'terabytes'
  UNIT_BYTES_PER_SEC = 'bytes_per_sec'
  UNIT_KILOBYTES_PER_SEC = 'kilobytes_per_sec'
  UNIT_MEGABYTES_PER_SEC = 'megabytes_per_sec'
  UNIT_GIGABYTES_PER_SEC = 'gigabytes_per_sec'
  UNIT_TERABYTES_PER_SEC = 'terabytes_per_sec'
  UNIT_NONE = 'none'
  NA_STRING = 'non_applicable_string_value'

  __slots__ = ['header','metric_name','unit','value','time_stamp','dimensions']
  _slot_types = ['std_msgs/Header','string','string','float64','time','ros_monitoring_msgs/MetricDimension[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,metric_name,unit,value,time_stamp,dimensions

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MetricData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.metric_name is None:
        self.metric_name = ''
      if self.unit is None:
        self.unit = ''
      if self.value is None:
        self.value = 0.
      if self.time_stamp is None:
        self.time_stamp = genpy.Time()
      if self.dimensions is None:
        self.dimensions = []
    else:
      self.header = std_msgs.msg.Header()
      self.metric_name = ''
      self.unit = ''
      self.value = 0.
      self.time_stamp = genpy.Time()
      self.dimensions = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.metric_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.unit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_d2I().pack(_x.value, _x.time_stamp.secs, _x.time_stamp.nsecs))
      length = len(self.dimensions)
      buff.write(_struct_I.pack(length))
      for val1 in self.dimensions:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time_stamp is None:
        self.time_stamp = genpy.Time()
      if self.dimensions is None:
        self.dimensions = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.metric_name = str[start:end].decode('utf-8')
      else:
        self.metric_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.unit = str[start:end].decode('utf-8')
      else:
        self.unit = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.value, _x.time_stamp.secs, _x.time_stamp.nsecs,) = _get_struct_d2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dimensions = []
      for i in range(0, length):
        val1 = ros_monitoring_msgs.msg.MetricDimension()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8')
        else:
          val1.value = str[start:end]
        self.dimensions.append(val1)
      self.time_stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.metric_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.unit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_d2I().pack(_x.value, _x.time_stamp.secs, _x.time_stamp.nsecs))
      length = len(self.dimensions)
      buff.write(_struct_I.pack(length))
      for val1 in self.dimensions:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.value
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.time_stamp is None:
        self.time_stamp = genpy.Time()
      if self.dimensions is None:
        self.dimensions = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.metric_name = str[start:end].decode('utf-8')
      else:
        self.metric_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.unit = str[start:end].decode('utf-8')
      else:
        self.unit = str[start:end]
      _x = self
      start = end
      end += 16
      (_x.value, _x.time_stamp.secs, _x.time_stamp.nsecs,) = _get_struct_d2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.dimensions = []
      for i in range(0, length):
        val1 = ros_monitoring_msgs.msg.MetricDimension()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.value = str[start:end].decode('utf-8')
        else:
          val1.value = str[start:end]
        self.dimensions.append(val1)
      self.time_stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_d2I = None
def _get_struct_d2I():
    global _struct_d2I
    if _struct_d2I is None:
        _struct_d2I = struct.Struct("<d2I")
    return _struct_d2I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
