// Auto-generated. Do not edit!

// (in-package ros_monitoring_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MetricDimension = require('./MetricDimension.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class MetricData {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.metric_name = null;
      this.unit = null;
      this.value = null;
      this.time_stamp = null;
      this.dimensions = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('metric_name')) {
        this.metric_name = initObj.metric_name
      }
      else {
        this.metric_name = '';
      }
      if (initObj.hasOwnProperty('unit')) {
        this.unit = initObj.unit
      }
      else {
        this.unit = '';
      }
      if (initObj.hasOwnProperty('value')) {
        this.value = initObj.value
      }
      else {
        this.value = 0.0;
      }
      if (initObj.hasOwnProperty('time_stamp')) {
        this.time_stamp = initObj.time_stamp
      }
      else {
        this.time_stamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('dimensions')) {
        this.dimensions = initObj.dimensions
      }
      else {
        this.dimensions = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MetricData
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [metric_name]
    bufferOffset = _serializer.string(obj.metric_name, buffer, bufferOffset);
    // Serialize message field [unit]
    bufferOffset = _serializer.string(obj.unit, buffer, bufferOffset);
    // Serialize message field [value]
    bufferOffset = _serializer.float64(obj.value, buffer, bufferOffset);
    // Serialize message field [time_stamp]
    bufferOffset = _serializer.time(obj.time_stamp, buffer, bufferOffset);
    // Serialize message field [dimensions]
    // Serialize the length for message field [dimensions]
    bufferOffset = _serializer.uint32(obj.dimensions.length, buffer, bufferOffset);
    obj.dimensions.forEach((val) => {
      bufferOffset = MetricDimension.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MetricData
    let len;
    let data = new MetricData(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [metric_name]
    data.metric_name = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [unit]
    data.unit = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [value]
    data.value = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [time_stamp]
    data.time_stamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [dimensions]
    // Deserialize array length for message field [dimensions]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.dimensions = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.dimensions[i] = MetricDimension.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += object.metric_name.length;
    length += object.unit.length;
    object.dimensions.forEach((val) => {
      length += MetricDimension.getMessageSize(val);
    });
    return length + 28;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ros_monitoring_msgs/MetricData';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f32b9a0e7a8e0cc5e657261689f3e49d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    std_msgs/Header header
    
    # Constants for commonly used units
    string UNIT_SEC=sec
    string UNIT_MILLI_SEC=msec
    string UNIT_MICRO_SEC=usec
    string UNIT_PERCENTAGE=percent
    string UNIT_COUNT=count
    string UNIT_COUNT_PER_SEC=count_per_sec
    string UNIT_BYTES=bytes
    string UNIT_KILOBYTES=kilobytes
    string UNIT_MEGABYTES=megabytes
    string UNIT_GIGABYTES=gigabytes
    string UNIT_TERABYTES=terabytes
    string UNIT_BYTES_PER_SEC=bytes_per_sec
    string UNIT_KILOBYTES_PER_SEC=kilobytes_per_sec
    string UNIT_MEGABYTES_PER_SEC=megabytes_per_sec
    string UNIT_GIGABYTES_PER_SEC=gigabytes_per_sec
    string UNIT_TERABYTES_PER_SEC=terabytes_per_sec
    string UNIT_NONE=none
    
    # Constant for NA string
    string NA_STRING=non_applicable_string_value
    
    #####################################
    # required fields
    
    # The name for the metric
    string metric_name
    
    # The units applied to the value
    string unit
    
    # The value of the metric
    float64 value
    
    # The time since the epoch
    time time_stamp
    
    # optional Custom dimensions used to group/sort metrics
    MetricDimension[] dimensions
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ros_monitoring_msgs/MetricDimension
    ###################################
    # Metric Dimensions provide an additional way to group, sort, and filter metrics.
    #
    # For example, you may have a large number of robots running in different factories. They are all publishing a metric
    # that indicates how long it takes them to perform a specific task. If we're just looking at all the metrics coming from
    # all the robots then we lose the ability to figure out things like if robots in one factory take longer to perform a
    # task than in another factory. Dimensions allow us to solve this by include a dimension name "factory" with the factory
    # name the robot is running in with each metric it publishes. Then we could look at the metrics for all robots or filter
    # down to just robots in a specific factory.
    #
    # Additionally, if we wanted to A/B test software versions we could add another dimension named "software_version" that
    # has a value set to the version of software the metric is produced from. Then we could group by the version of software
    # as well as which factory the robot is in.
    #
    ###################################
    
    # The name of the Metric Dimension
    string name
    
    # The value for the dimension
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MetricData(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.metric_name !== undefined) {
      resolved.metric_name = msg.metric_name;
    }
    else {
      resolved.metric_name = ''
    }

    if (msg.unit !== undefined) {
      resolved.unit = msg.unit;
    }
    else {
      resolved.unit = ''
    }

    if (msg.value !== undefined) {
      resolved.value = msg.value;
    }
    else {
      resolved.value = 0.0
    }

    if (msg.time_stamp !== undefined) {
      resolved.time_stamp = msg.time_stamp;
    }
    else {
      resolved.time_stamp = {secs: 0, nsecs: 0}
    }

    if (msg.dimensions !== undefined) {
      resolved.dimensions = new Array(msg.dimensions.length);
      for (let i = 0; i < resolved.dimensions.length; ++i) {
        resolved.dimensions[i] = MetricDimension.Resolve(msg.dimensions[i]);
      }
    }
    else {
      resolved.dimensions = []
    }

    return resolved;
    }
};

// Constants for message
MetricData.Constants = {
  UNIT_SEC: 'sec',
  UNIT_MILLI_SEC: 'msec',
  UNIT_MICRO_SEC: 'usec',
  UNIT_PERCENTAGE: 'percent',
  UNIT_COUNT: 'count',
  UNIT_COUNT_PER_SEC: 'count_per_sec',
  UNIT_BYTES: 'bytes',
  UNIT_KILOBYTES: 'kilobytes',
  UNIT_MEGABYTES: 'megabytes',
  UNIT_GIGABYTES: 'gigabytes',
  UNIT_TERABYTES: 'terabytes',
  UNIT_BYTES_PER_SEC: 'bytes_per_sec',
  UNIT_KILOBYTES_PER_SEC: 'kilobytes_per_sec',
  UNIT_MEGABYTES_PER_SEC: 'megabytes_per_sec',
  UNIT_GIGABYTES_PER_SEC: 'gigabytes_per_sec',
  UNIT_TERABYTES_PER_SEC: 'terabytes_per_sec',
  UNIT_NONE: 'none',
  NA_STRING: 'non_applicable_string_value',
}

module.exports = MetricData;
