// Auto-generated. Do not edit!

// (in-package ros_monitoring_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MetricData = require('./MetricData.js');

//-----------------------------------------------------------

class MetricList {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.metrics = null;
    }
    else {
      if (initObj.hasOwnProperty('metrics')) {
        this.metrics = initObj.metrics
      }
      else {
        this.metrics = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MetricList
    // Serialize message field [metrics]
    // Serialize the length for message field [metrics]
    bufferOffset = _serializer.uint32(obj.metrics.length, buffer, bufferOffset);
    obj.metrics.forEach((val) => {
      bufferOffset = MetricData.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MetricList
    let len;
    let data = new MetricList(null);
    // Deserialize message field [metrics]
    // Deserialize array length for message field [metrics]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.metrics = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.metrics[i] = MetricData.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.metrics.forEach((val) => {
      length += MetricData.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ros_monitoring_msgs/MetricList';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f72191c1af1e3061e2cd046d2b64d168';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ###################################
    # MetricList enables aggregation of multiple metrics into one message
    ###################################
    
    MetricData[] metrics
    
    ================================================================================
    MSG: ros_monitoring_msgs/MetricData
    std_msgs/Header header
    
    # Constants for commonly used units
    string UNIT_SEC=sec
    string UNIT_MILLI_SEC=msec
    string UNIT_MICRO_SEC=usec
    string UNIT_PERCENTAGE=percent
    string UNIT_COUNT=count
    string UNIT_COUNT_PER_SEC=count_per_sec
    string UNIT_BYTES=bytes
    string UNIT_KILOBYTES=kilobytes
    string UNIT_MEGABYTES=megabytes
    string UNIT_GIGABYTES=gigabytes
    string UNIT_TERABYTES=terabytes
    string UNIT_BYTES_PER_SEC=bytes_per_sec
    string UNIT_KILOBYTES_PER_SEC=kilobytes_per_sec
    string UNIT_MEGABYTES_PER_SEC=megabytes_per_sec
    string UNIT_GIGABYTES_PER_SEC=gigabytes_per_sec
    string UNIT_TERABYTES_PER_SEC=terabytes_per_sec
    string UNIT_NONE=none
    
    # Constant for NA string
    string NA_STRING=non_applicable_string_value
    
    #####################################
    # required fields
    
    # The name for the metric
    string metric_name
    
    # The units applied to the value
    string unit
    
    # The value of the metric
    float64 value
    
    # The time since the epoch
    time time_stamp
    
    # optional Custom dimensions used to group/sort metrics
    MetricDimension[] dimensions
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: ros_monitoring_msgs/MetricDimension
    ###################################
    # Metric Dimensions provide an additional way to group, sort, and filter metrics.
    #
    # For example, you may have a large number of robots running in different factories. They are all publishing a metric
    # that indicates how long it takes them to perform a specific task. If we're just looking at all the metrics coming from
    # all the robots then we lose the ability to figure out things like if robots in one factory take longer to perform a
    # task than in another factory. Dimensions allow us to solve this by include a dimension name "factory" with the factory
    # name the robot is running in with each metric it publishes. Then we could look at the metrics for all robots or filter
    # down to just robots in a specific factory.
    #
    # Additionally, if we wanted to A/B test software versions we could add another dimension named "software_version" that
    # has a value set to the version of software the metric is produced from. Then we could group by the version of software
    # as well as which factory the robot is in.
    #
    ###################################
    
    # The name of the Metric Dimension
    string name
    
    # The value for the dimension
    string value
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MetricList(null);
    if (msg.metrics !== undefined) {
      resolved.metrics = new Array(msg.metrics.length);
      for (let i = 0; i < resolved.metrics.length; ++i) {
        resolved.metrics[i] = MetricData.Resolve(msg.metrics[i]);
      }
    }
    else {
      resolved.metrics = []
    }

    return resolved;
    }
};

module.exports = MetricList;
